		title execute_example

;Second example of the execute function.
;In this example you are obliged to give
;both the name of the program to execute
;and the arguments passed to that program.

;link with incprocs.obj and execargs.obj.


	
	stacksize 		equ 	512
	max_len_childname	equ	260
	max_len_commandtail	equ	260

	stack group Data_seg, Stack_seg

Code_seg segment public 'code'

assume cs:Code_seg,ds:Data_seg,ss:Stack_seg

extrn  	get_childnm_and_stdcmndline	:near
extrn	error_handling			:near

	mov	ax,	stack
	mov	ds,	ax	
	
;free a lot of memory( because even exes ask for all)
	mov	ax,	es		
	mov	bx,	ss		
	sub	bx,	ax		
	add	bx,	stacksize/16
	mov	ah,	4ah
	int	21h
	jc 	error

;get childprogram_name and commandparams
	push	ds
	pop	es
	call	get_childnm_and_stdcmndline

;call the exec function
	mov 	ah,	4bh
	mov 	al,	0
	lea	dx,	child_name
	lea	bx,	params
	int	21h
	jc 	error
done:	mov	ah,	04ch
	int	21h

error:	call	error_handling
	jmp	done

Code_seg ends

Data_seg segment public 'data'


public	child_name	
public	len_cmndline	
public	commandtail

child_name		db	max_len_childname dup(?)

len_cmndline		db 	?
commandtail		db	max_len_commandtail+1 dup(?)

Dummy			db	20h dup(0)

Params			dw	0
			dd	len_cmndline
			dd	Dummy,Dummy   ;this way defining FAR ptrs!

Data_seg ends		


Stack_seg segment stack 'stack'

stackjes		db	stacksize dup(?)

Stack_seg ends

END
